public class Person {
    private String name;
    
    public Person(String name) {
        if (name == null) throw new NullPointerException("Name must be given");
        this.name = name;
    }
    
    @Override
    public String toString() {
        return name;
    }
    
    // Both equals AND hashCode MUST BE OVERRIDEN when using HashSet/HashMap
    @Override 
    public boolean equals(Object o) {
        if(o == null) return false;
        if(this.getClass() != o.getClass()) return false;
        Person p = (Person)o;
        return this.name.equals(p.name);
    }
    
    // If you just override equals BUT NOT hashCode
    // then HashSet will not work!!!
    // Try to comment hashCode() out...
    @Override
    public int hashCode() {
        return name.hashCode();
    }
}